diff a/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/io_uring_cqe.java b/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/io_uring_cqe.java
--- /dev/null
+++ b/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/io_uring_cqe.java
@@ -0,0 +1,157 @@
+// Generated by jextract
+
+package jdk.internal.ffi.generated.iouring;
+
+import java.lang.invoke.*;
+import java.lang.foreign.*;
+import java.nio.ByteOrder;
+import java.util.*;
+import java.util.function.*;
+import java.util.stream.*;
+
+import static java.lang.foreign.ValueLayout.*;
+import static java.lang.foreign.MemoryLayout.PathElement.*;
+
+/**
+ * {@snippet lang=c :
+ * struct io_uring_cqe {
+ *     __u64 user_data;
+ *     __s32 res;
+ *     __u32 flags;
+ *     __u64 big_cqe[];
+ * }
+ * }
+ */
+@SuppressWarnings("restricted") public class io_uring_cqe {
+
+    io_uring_cqe() {
+        // Suppresses public default constructor, ensuring non-instantiability,
+        // but allows generated subclasses in same package.
+    }
+
+    private static final GroupLayout $LAYOUT = MemoryLayout.structLayout(
+        iouring_h.C_LONG_LONG.withName("user_data"),
+        iouring_h.C_INT.withName("res"),
+        iouring_h.C_INT.withName("flags"),
+        MemoryLayout.sequenceLayout(0, iouring_h.C_LONG_LONG).withName("big_cqe")
+    ).withName("io_uring_cqe");
+
+    public static final GroupLayout $LAYOUT() {
+        return $LAYOUT;
+    }
+
+    private static final long user_data$OFFSET = 0;
+    private static final OfLong user_data$LAYOUT = (OfLong)$LAYOUT.select(groupElement("user_data"));
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * __u64 user_data
+     * }
+     */
+    public static long user_data(MemorySegment struct) {
+        return struct.get(user_data$LAYOUT, user_data$OFFSET);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * __u64 user_data
+     * }
+     */
+    public static void user_data(MemorySegment struct, long fieldValue) {
+        struct.set(user_data$LAYOUT, user_data$OFFSET, fieldValue);
+    }
+
+    private static final long res$OFFSET = 8;
+    private static final OfInt res$LAYOUT = (OfInt)$LAYOUT.select(groupElement("res"));
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * __s32 res
+     * }
+     */
+    public static int res(MemorySegment struct) {
+        return struct.get(res$LAYOUT, res$OFFSET);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * __s32 res
+     * }
+     */
+    public static void res(MemorySegment struct, int fieldValue) {
+        struct.set(res$LAYOUT, res$OFFSET, fieldValue);
+    }
+
+    private static final long flags$OFFSET = 12;
+    private static final OfInt flags$LAYOUT = (OfInt)$LAYOUT.select(groupElement("flags"));
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * __u32 flags
+     * }
+     */
+    public static int flags(MemorySegment struct) {
+        return struct.get(flags$LAYOUT, flags$OFFSET);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * __u32 flags
+     * }
+     */
+    public static void flags(MemorySegment struct, int fieldValue) {
+        struct.set(flags$LAYOUT, flags$OFFSET, fieldValue);
+    }
+
+    private static final long big_cqe$OFFSET = 16;
+    private static final long big_cqe$SIZE = 0;
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * __u64 big_cqe[]
+     * }
+     */
+    public static MemorySegment big_cqe(MemorySegment struct) {
+        return struct.asSlice(big_cqe$OFFSET, big_cqe$SIZE);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * __u64 big_cqe[]
+     * }
+     */
+    public static void big_cqe(MemorySegment struct, MemorySegment fieldValue) {
+        MemorySegment.copy(fieldValue, 0L, struct, big_cqe$OFFSET, big_cqe$SIZE);
+    }
+
+    public static MemorySegment asSlice(MemorySegment array, long index) {
+        return array.asSlice($LAYOUT().byteSize() * index);
+    }
+
+    public static long sizeof() { return $LAYOUT().byteSize(); }
+
+    public static MemorySegment allocate(SegmentAllocator allocator) {
+        return allocator.allocate($LAYOUT());
+    }
+
+    public static MemorySegment allocateArray(long elementCount, SegmentAllocator allocator) {
+        return allocator.allocate(MemoryLayout.sequenceLayout(elementCount, $LAYOUT()));
+    }
+
+    public static MemorySegment reinterpret(MemorySegment addr, Arena scope, Consumer<MemorySegment> cleanup) {
+        return reinterpret(addr, 1, scope, cleanup);
+    }
+
+    public static MemorySegment reinterpret(MemorySegment addr, long elementCount, Arena scope, Consumer<MemorySegment> cleanup) {
+        return addr.reinterpret($LAYOUT().byteSize() * elementCount, scope, cleanup);
+    }
+}
+