diff a/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/sockaddr_in.java b/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/sockaddr_in.java
--- /dev/null
+++ b/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/sockaddr_in.java
@@ -0,0 +1,157 @@
+// Generated by jextract
+
+package jdk.internal.ffi.generated.iouring;
+
+import java.lang.invoke.*;
+import java.lang.foreign.*;
+import java.nio.ByteOrder;
+import java.util.*;
+import java.util.function.*;
+import java.util.stream.*;
+
+import static java.lang.foreign.ValueLayout.*;
+import static java.lang.foreign.MemoryLayout.PathElement.*;
+
+/**
+ * {@snippet lang=c :
+ * struct sockaddr_in {
+ *     sa_family_t sin_family;
+ *     in_port_t sin_port;
+ *     struct in_addr sin_addr;
+ *     unsigned char sin_zero[8];
+ * }
+ * }
+ */
+@SuppressWarnings("restricted") public class sockaddr_in {
+
+    sockaddr_in() {
+        // Suppresses public default constructor, ensuring non-instantiability,
+        // but allows generated subclasses in same package.
+    }
+
+    private static final GroupLayout $LAYOUT = MemoryLayout.structLayout(
+        iouring_h.C_SHORT.withName("sin_family"),
+        iouring_h.C_SHORT.withName("sin_port"),
+        in_addr.$LAYOUT().withName("sin_addr"),
+        MemoryLayout.sequenceLayout(8, iouring_h.C_CHAR).withName("sin_zero")
+    ).withName("sockaddr_in");
+
+    public static final GroupLayout $LAYOUT() {
+        return $LAYOUT;
+    }
+
+    private static final long sin_family$OFFSET = 0;
+    private static final OfShort sin_family$LAYOUT = (OfShort)$LAYOUT.select(groupElement("sin_family"));
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * sa_family_t sin_family
+     * }
+     */
+    public static short sin_family(MemorySegment struct) {
+        return struct.get(sin_family$LAYOUT, sin_family$OFFSET);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * sa_family_t sin_family
+     * }
+     */
+    public static void sin_family(MemorySegment struct, short fieldValue) {
+        struct.set(sin_family$LAYOUT, sin_family$OFFSET, fieldValue);
+    }
+
+    private static final long sin_port$OFFSET = 2;
+    private static final OfShort sin_port$LAYOUT = ((OfShort)$LAYOUT.select(groupElement("sin_port"))).withOrder(ByteOrder.BIG_ENDIAN);
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * in_port_t sin_port
+     * }
+     */
+    public static short sin_port(MemorySegment struct) {
+        return struct.get(sin_port$LAYOUT, sin_port$OFFSET);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * in_port_t sin_port
+     * }
+     */
+    public static void sin_port(MemorySegment struct, short fieldValue) {
+        struct.set(sin_port$LAYOUT, sin_port$OFFSET, fieldValue);
+    }
+
+    private static final long sin_addr$OFFSET = 4;
+    private static final long sin_addr$SIZE = 4;
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * struct in_addr sin_addr
+     * }
+     */
+    public static MemorySegment sin_addr(MemorySegment struct) {
+        return struct.asSlice(sin_addr$OFFSET, sin_addr$SIZE);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * struct in_addr sin_addr
+     * }
+     */
+    public static void sin_addr(MemorySegment struct, MemorySegment fieldValue) {
+        MemorySegment.copy(fieldValue, 0L, struct, sin_addr$OFFSET, sin_addr$SIZE);
+    }
+
+    private static final long sin_zero$OFFSET = 8;
+    private static final long sin_zero$SIZE = 8;
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * unsigned char sin_zero[8]
+     * }
+     */
+    public static MemorySegment sin_zero(MemorySegment struct) {
+        return struct.asSlice(sin_zero$OFFSET, sin_zero$SIZE);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * unsigned char sin_zero[8]
+     * }
+     */
+    public static void sin_zero(MemorySegment struct, MemorySegment fieldValue) {
+        MemorySegment.copy(fieldValue, 0L, struct, sin_zero$OFFSET, sin_zero$SIZE);
+    }
+
+    public static MemorySegment asSlice(MemorySegment array, long index) {
+        return array.asSlice($LAYOUT().byteSize() * index);
+    }
+
+    public static long sizeof() { return $LAYOUT().byteSize(); }
+
+    public static MemorySegment allocate(SegmentAllocator allocator) {
+        return allocator.allocate($LAYOUT());
+    }
+
+    public static MemorySegment allocateArray(long elementCount, SegmentAllocator allocator) {
+        return allocator.allocate(MemoryLayout.sequenceLayout(elementCount, $LAYOUT()));
+    }
+
+    public static MemorySegment reinterpret(MemorySegment addr, Arena scope, Consumer<MemorySegment> cleanup) {
+        return reinterpret(addr, 1, scope, cleanup);
+    }
+
+    public static MemorySegment reinterpret(MemorySegment addr, long elementCount, Arena scope, Consumer<MemorySegment> cleanup) {
+        return addr.reinterpret($LAYOUT().byteSize() * elementCount, scope, cleanup);
+    }
+}
+