diff a/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/sockaddr_storage.java b/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/sockaddr_storage.java
--- /dev/null
+++ b/src/java.base/linux/classes/jdk/internal/ffi/generated/iouring/sockaddr_storage.java
@@ -0,0 +1,132 @@
+// Generated by jextract
+
+package jdk.internal.ffi.generated.iouring;
+
+import java.lang.invoke.*;
+import java.lang.foreign.*;
+import java.nio.ByteOrder;
+import java.util.*;
+import java.util.function.*;
+import java.util.stream.*;
+
+import static java.lang.foreign.ValueLayout.*;
+import static java.lang.foreign.MemoryLayout.PathElement.*;
+
+/**
+ * {@snippet lang=c :
+ * struct sockaddr_storage {
+ *     sa_family_t ss_family;
+ *     char __ss_padding[118];
+ *     unsigned long __ss_align;
+ * }
+ * }
+ */
+@SuppressWarnings("restricted") public class sockaddr_storage {
+
+    sockaddr_storage() {
+        // Suppresses public default constructor, ensuring non-instantiability,
+        // but allows generated subclasses in same package.
+    }
+
+    private static final GroupLayout $LAYOUT = MemoryLayout.structLayout(
+        iouring_h.C_SHORT.withName("ss_family"),
+        MemoryLayout.sequenceLayout(118, iouring_h.C_CHAR).withName("__ss_padding"),
+        iouring_h.C_LONG.withName("__ss_align")
+    ).withName("sockaddr_storage");
+
+    public static final GroupLayout $LAYOUT() {
+        return $LAYOUT;
+    }
+
+    private static final long ss_family$OFFSET = 0;
+    private static final OfShort ss_family$LAYOUT = (OfShort)$LAYOUT.select(groupElement("ss_family"));
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * sa_family_t ss_family
+     * }
+     */
+    public static short ss_family(MemorySegment struct) {
+        return struct.get(ss_family$LAYOUT, ss_family$OFFSET);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * sa_family_t ss_family
+     * }
+     */
+    public static void ss_family(MemorySegment struct, short fieldValue) {
+        struct.set(ss_family$LAYOUT, ss_family$OFFSET, fieldValue);
+    }
+
+    private static final long __ss_padding$OFFSET = 2;
+    private static final long __ss_padding$SIZE = 118;
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * char __ss_padding[118]
+     * }
+     */
+    public static MemorySegment __ss_padding(MemorySegment struct) {
+        return struct.asSlice(__ss_padding$OFFSET, __ss_padding$SIZE);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * char __ss_padding[118]
+     * }
+     */
+    public static void __ss_padding(MemorySegment struct, MemorySegment fieldValue) {
+        MemorySegment.copy(fieldValue, 0L, struct, __ss_padding$OFFSET, __ss_padding$SIZE);
+    }
+
+    private static final long __ss_align$OFFSET = 120;
+    private static final OfLong __ss_align$LAYOUT = (OfLong)$LAYOUT.select(groupElement("__ss_align"));
+
+    /**
+     * Getter for field:
+     * {@snippet lang=c :
+     * unsigned long __ss_align
+     * }
+     */
+    public static long __ss_align(MemorySegment struct) {
+        return struct.get(__ss_align$LAYOUT, __ss_align$OFFSET);
+    }
+
+    /**
+     * Setter for field:
+     * {@snippet lang=c :
+     * unsigned long __ss_align
+     * }
+     */
+    public static void __ss_align(MemorySegment struct, long fieldValue) {
+        struct.set(__ss_align$LAYOUT, __ss_align$OFFSET, fieldValue);
+    }
+
+    public static MemorySegment asSlice(MemorySegment array, long index) {
+        return array.asSlice($LAYOUT().byteSize() * index);
+    }
+
+    public static long sizeof() { return $LAYOUT().byteSize(); }
+
+    public static MemorySegment allocate(SegmentAllocator allocator) {
+        return allocator.allocate($LAYOUT());
+    }
+
+    public static MemorySegment allocateArray(long elementCount, SegmentAllocator allocator) {
+        return allocator.allocate(MemoryLayout.sequenceLayout(elementCount, $LAYOUT()));
+    }
+
+    public static MemorySegment reinterpret(MemorySegment addr, Arena scope, Consumer<MemorySegment> cleanup) {
+        return reinterpret(addr, 1, scope, cleanup);
+    }
+
+    public static MemorySegment reinterpret(MemorySegment addr, long elementCount, Arena scope, Consumer<MemorySegment> cleanup) {
+        return addr.reinterpret($LAYOUT().byteSize() * elementCount, scope, cleanup);
+    }
+}
+